;	C STARTUP FOR S12HY64
;	WITH AUTOMATIC DATA INITIALISATION
;	Copyright (c) 2009 by COSMIC Software
;
	xdef	_exit, __stext
	xref	_main, __sbss, __memory, __idesc__, __stack
	xref    _DIRECT, __sdirect
;
__stext:
	lds	#__stack	; initialize stack pointer
	movb #high(__sdirect), _DIRECT  ; initialize direct reg
ifdef PIC
	leax	__idesc__,pcr	; descriptor address
ifdef MCX
	subx	#__idesc__	; code offset
	pshx			; on the stack
else
	tfr	x,d		; compute
	subd	#__idesc__	; code offset
	pshd			; on the stack
endif
else
	ldx	#__idesc__	; descriptor address
endif
	ldy	2,x+		; start address of prom data
ibcl:
	ldaa	5,x+		; test flag byte
	beq	zbss		; no more segment
	bpl	nopg		; page indicator
	leax	2,x		; skip it
nopg:
	bita	#$60		; test for moveable code segment
	bne	dseg		; no, copy it
	ldy	-2,x		; reload code address
	bra	ibcl		; and continue with next segment
dseg:
	pshx			; save pointer
	tfr	y,d		; start address
	subd	-2,x		; minus end address
	ldx	-4,x		; destination address
ifdef PIC
ifdef MCX
	addy	2,s		; adjust code offset
else
	exg	d,y		; adjust
	addd	2,s		; code address
	exg	d,y
endif
endif
dbcl:
	movb	1,y+,1,x+	; copy from prom to ram
	ibne	d,dbcl		; count up and loop
ifdef PIC
ifdef MCX
	suby	2,s		; restore code address
else
	exg	d,y		; restore
	subd	2,s		; code address
	exg	d,y
endif
endif
	pulx			; reload pointer to desc
	bra	ibcl		; and loop
zbss:
	ldx	#__sbss		; start of bss
	clrb			; complete zero
	bra	loop		; start loop
zbcl:
	std	2,x+		; clear word
loop:
	cpx	#__memory	; end of bss
	blo	zbcl		; no, continue
ifdef PIC
	puld			; clean stack
	lbsr	_main		; execute main
else
	jsr	_main		; execute main
endif
_exit:
	bra	_exit		; stay here
;
	end
